// Compiled by ClojureScript 1.9.562 {}
goog.provide('hoplon.jquery');
goog.require('cljs.core');
goog.require('hoplon.core');
hoplon.jquery.set_attributes_BANG_ = (function hoplon$jquery$set_attributes_BANG_(var_args){
var args30455 = [];
var len__24559__auto___30474 = arguments.length;
var i__24560__auto___30475 = (0);
while(true){
if((i__24560__auto___30475 < len__24559__auto___30474)){
args30455.push((arguments[i__24560__auto___30475]));

var G__30476 = (i__24560__auto___30475 + (1));
i__24560__auto___30475 = G__30476;
continue;
} else {
}
break;
}

var G__30461 = args30455.length;
switch (G__30461) {
case 2:
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__24582__auto__ = (new cljs.core.IndexedSeq(args30455.slice((3)),(0),null));
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__24582__auto__);

}
});

hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (this$,kvs){
var e = jQuery(this$);
var seq__30462 = cljs.core.seq.call(null,kvs);
var chunk__30464 = null;
var count__30465 = (0);
var i__30466 = (0);
while(true){
if((i__30466 < count__30465)){
var vec__30468 = cljs.core._nth.call(null,chunk__30464,i__30466);
var k = cljs.core.nth.call(null,vec__30468,(0),null);
var v = cljs.core.nth.call(null,vec__30468,(1),null);
var k_30478__$1 = cljs.core.name.call(null,k);
if(cljs.core.not.call(null,v)){
e.removeAttr(k_30478__$1);
} else {
e.attr(k_30478__$1,((cljs.core._EQ_.call(null,true,v))?k_30478__$1:v));
}

var G__30479 = seq__30462;
var G__30480 = chunk__30464;
var G__30481 = count__30465;
var G__30482 = (i__30466 + (1));
seq__30462 = G__30479;
chunk__30464 = G__30480;
count__30465 = G__30481;
i__30466 = G__30482;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30462);
if(temp__5278__auto__){
var seq__30462__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30462__$1)){
var c__24249__auto__ = cljs.core.chunk_first.call(null,seq__30462__$1);
var G__30483 = cljs.core.chunk_rest.call(null,seq__30462__$1);
var G__30484 = c__24249__auto__;
var G__30485 = cljs.core.count.call(null,c__24249__auto__);
var G__30486 = (0);
seq__30462 = G__30483;
chunk__30464 = G__30484;
count__30465 = G__30485;
i__30466 = G__30486;
continue;
} else {
var vec__30471 = cljs.core.first.call(null,seq__30462__$1);
var k = cljs.core.nth.call(null,vec__30471,(0),null);
var v = cljs.core.nth.call(null,vec__30471,(1),null);
var k_30487__$1 = cljs.core.name.call(null,k);
if(cljs.core.not.call(null,v)){
e.removeAttr(k_30487__$1);
} else {
e.attr(k_30487__$1,((cljs.core._EQ_.call(null,true,v))?k_30487__$1:v));
}

var G__30488 = cljs.core.next.call(null,seq__30462__$1);
var G__30489 = null;
var G__30490 = (0);
var G__30491 = (0);
seq__30462 = G__30488;
chunk__30464 = G__30489;
count__30465 = G__30490;
i__30466 = G__30491;
continue;
}
} else {
return null;
}
}
break;
}
});

hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (this$,k,v,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,this$,cljs.core.apply.call(null,cljs.core.hash_map,k,v,kvs));
});

hoplon.jquery.set_attributes_BANG_.cljs$lang$applyTo = (function (seq30456){
var G__30457 = cljs.core.first.call(null,seq30456);
var seq30456__$1 = cljs.core.next.call(null,seq30456);
var G__30458 = cljs.core.first.call(null,seq30456__$1);
var seq30456__$2 = cljs.core.next.call(null,seq30456__$1);
var G__30459 = cljs.core.first.call(null,seq30456__$2);
var seq30456__$3 = cljs.core.next.call(null,seq30456__$2);
return hoplon.jquery.set_attributes_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__30457,G__30458,G__30459,seq30456__$3);
});

hoplon.jquery.set_attributes_BANG_.cljs$lang$maxFixedArity = (3);

hoplon.jquery.set_styles_BANG_ = (function hoplon$jquery$set_styles_BANG_(var_args){
var args30492 = [];
var len__24559__auto___30509 = arguments.length;
var i__24560__auto___30510 = (0);
while(true){
if((i__24560__auto___30510 < len__24559__auto___30509)){
args30492.push((arguments[i__24560__auto___30510]));

var G__30511 = (i__24560__auto___30510 + (1));
i__24560__auto___30510 = G__30511;
continue;
} else {
}
break;
}

var G__30498 = args30492.length;
switch (G__30498) {
case 2:
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
var argseq__24582__auto__ = (new cljs.core.IndexedSeq(args30492.slice((3)),(0),null));
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__24582__auto__);

}
});

hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (this$,kvs){
var e = jQuery(this$);
var seq__30499 = cljs.core.seq.call(null,kvs);
var chunk__30500 = null;
var count__30501 = (0);
var i__30502 = (0);
while(true){
if((i__30502 < count__30501)){
var vec__30503 = cljs.core._nth.call(null,chunk__30500,i__30502);
var k = cljs.core.nth.call(null,vec__30503,(0),null);
var v = cljs.core.nth.call(null,vec__30503,(1),null);
e.css(cljs.core.name.call(null,k),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));

var G__30513 = seq__30499;
var G__30514 = chunk__30500;
var G__30515 = count__30501;
var G__30516 = (i__30502 + (1));
seq__30499 = G__30513;
chunk__30500 = G__30514;
count__30501 = G__30515;
i__30502 = G__30516;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30499);
if(temp__5278__auto__){
var seq__30499__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30499__$1)){
var c__24249__auto__ = cljs.core.chunk_first.call(null,seq__30499__$1);
var G__30517 = cljs.core.chunk_rest.call(null,seq__30499__$1);
var G__30518 = c__24249__auto__;
var G__30519 = cljs.core.count.call(null,c__24249__auto__);
var G__30520 = (0);
seq__30499 = G__30517;
chunk__30500 = G__30518;
count__30501 = G__30519;
i__30502 = G__30520;
continue;
} else {
var vec__30506 = cljs.core.first.call(null,seq__30499__$1);
var k = cljs.core.nth.call(null,vec__30506,(0),null);
var v = cljs.core.nth.call(null,vec__30506,(1),null);
e.css(cljs.core.name.call(null,k),[cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));

var G__30521 = cljs.core.next.call(null,seq__30499__$1);
var G__30522 = null;
var G__30523 = (0);
var G__30524 = (0);
seq__30499 = G__30521;
chunk__30500 = G__30522;
count__30501 = G__30523;
i__30502 = G__30524;
continue;
}
} else {
return null;
}
}
break;
}
});

hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (this$,k,v,kvs){
return hoplon.jquery.set_styles_BANG_.call(null,this$,cljs.core.apply.call(null,cljs.core.hash_map,k,v,kvs));
});

hoplon.jquery.set_styles_BANG_.cljs$lang$applyTo = (function (seq30493){
var G__30494 = cljs.core.first.call(null,seq30493);
var seq30493__$1 = cljs.core.next.call(null,seq30493);
var G__30495 = cljs.core.first.call(null,seq30493__$1);
var seq30493__$2 = cljs.core.next.call(null,seq30493__$1);
var G__30496 = cljs.core.first.call(null,seq30493__$2);
var seq30493__$3 = cljs.core.next.call(null,seq30493__$2);
return hoplon.jquery.set_styles_BANG_.cljs$core$IFn$_invoke$arity$variadic(G__30494,G__30495,G__30496,seq30493__$3);
});

hoplon.jquery.set_styles_BANG_.cljs$lang$maxFixedArity = (3);

hoplon.jquery.text_val_BANG_ = (function hoplon$jquery$text_val_BANG_(var_args){
var args30525 = [];
var len__24559__auto___30528 = arguments.length;
var i__24560__auto___30529 = (0);
while(true){
if((i__24560__auto___30529 < len__24559__auto___30528)){
args30525.push((arguments[i__24560__auto___30529]));

var G__30530 = (i__24560__auto___30529 + (1));
i__24560__auto___30529 = G__30530;
continue;
} else {
}
break;
}

var G__30527 = args30525.length;
switch (G__30527) {
case 1:
return hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args30525.length)].join('')));

}
});

hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$1 = (function (e){
return e.val();
});

hoplon.jquery.text_val_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (e,v){
var v__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join('');
if(cljs.core.not_EQ_.call(null,v__$1,hoplon.jquery.text_val_BANG_.call(null,e))){
return e.val(v__$1);
} else {
return null;
}
});

hoplon.jquery.text_val_BANG_.cljs$lang$maxFixedArity = 2;

hoplon.jquery.check_val_BANG_ = (function hoplon$jquery$check_val_BANG_(var_args){
var args30532 = [];
var len__24559__auto___30535 = arguments.length;
var i__24560__auto___30536 = (0);
while(true){
if((i__24560__auto___30536 < len__24559__auto___30535)){
args30532.push((arguments[i__24560__auto___30536]));

var G__30537 = (i__24560__auto___30536 + (1));
i__24560__auto___30536 = G__30537;
continue;
} else {
}
break;
}

var G__30534 = args30532.length;
switch (G__30534) {
case 1:
return hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error([cljs.core.str.cljs$core$IFn$_invoke$arity$1("Invalid arity: "),cljs.core.str.cljs$core$IFn$_invoke$arity$1(args30532.length)].join('')));

}
});

hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$1 = (function (e){
return e.is(":checked");
});

hoplon.jquery.check_val_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (e,v){
return e.prop("checked",cljs.core.boolean$.call(null,v));
});

hoplon.jquery.check_val_BANG_.cljs$lang$maxFixedArity = 2;

cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("hoplon.core","default","hoplon.core/default",-778824365),(function (elem,key,val){
return hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"attr","attr",-604132353),cljs.core.PersistentArrayMap.createAsIfByAssoc([key,val]));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("css","*","css/*",-1295355419),(function (elem,key,val){
return hoplon.jquery.set_styles_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("html","*","html/*",-1283138243),(function (elem,key,val){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("svg","*","svg/*",-1295405562),(function (elem,key,val){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,key,val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("attr","*","attr/*",-1283077225),(function (elem,_,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("prop","*","prop/*",-1283942139),(function (elem,key,val){
var e = jQuery(elem);
return e.prop(cljs.core.name.call(null,key),val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword("data","*","data/*",-1283013312),(function (elem,key,val){
var e = jQuery(elem);
return e.data(cljs.core.name.call(null,key),val);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"attr","attr",-604132353),(function (elem,_,kvs){
return hoplon.jquery.set_attributes_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"css","css",1135045163),(function (elem,_,kvs){
return hoplon.jquery.set_styles_BANG_.call(null,elem,kvs);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"value","value",305978217),(function() { 
var G__30539__delegate = function (elem,_,args){
var e = jQuery(elem);
return cljs.core.apply.call(null,((cljs.core._EQ_.call(null,"checkbox",e.attr("type")))?hoplon.jquery.check_val_BANG_:hoplon.jquery.text_val_BANG_),e,args);
};
var G__30539 = function (elem,_,var_args){
var args = null;
if (arguments.length > 2) {
var G__30540__i = 0, G__30540__a = new Array(arguments.length -  2);
while (G__30540__i < G__30540__a.length) {G__30540__a[G__30540__i] = arguments[G__30540__i + 2]; ++G__30540__i;}
  args = new cljs.core.IndexedSeq(G__30540__a,0,null);
} 
return G__30539__delegate.call(this,elem,_,args);};
G__30539.cljs$lang$maxFixedArity = 2;
G__30539.cljs$lang$applyTo = (function (arglist__30541){
var elem = cljs.core.first(arglist__30541);
arglist__30541 = cljs.core.next(arglist__30541);
var _ = cljs.core.first(arglist__30541);
var args = cljs.core.rest(arglist__30541);
return G__30539__delegate(elem,_,args);
});
G__30539.cljs$core$IFn$_invoke$arity$variadic = G__30539__delegate;
return G__30539;
})()
);
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"class","class",-2030961996),(function (elem,_,kvs){
var elem__$1 = jQuery(elem);
var clmap = hoplon.core.normalize_class.call(null,kvs);
var seq__30542 = cljs.core.seq.call(null,clmap);
var chunk__30543 = null;
var count__30544 = (0);
var i__30545 = (0);
while(true){
if((i__30545 < count__30544)){
var vec__30546 = cljs.core._nth.call(null,chunk__30543,i__30545);
var c = cljs.core.nth.call(null,vec__30546,(0),null);
var p_QMARK_ = cljs.core.nth.call(null,vec__30546,(1),null);
elem__$1.toggleClass(cljs.core.name.call(null,c),cljs.core.boolean$.call(null,p_QMARK_));

var G__30552 = seq__30542;
var G__30553 = chunk__30543;
var G__30554 = count__30544;
var G__30555 = (i__30545 + (1));
seq__30542 = G__30552;
chunk__30543 = G__30553;
count__30544 = G__30554;
i__30545 = G__30555;
continue;
} else {
var temp__5278__auto__ = cljs.core.seq.call(null,seq__30542);
if(temp__5278__auto__){
var seq__30542__$1 = temp__5278__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__30542__$1)){
var c__24249__auto__ = cljs.core.chunk_first.call(null,seq__30542__$1);
var G__30556 = cljs.core.chunk_rest.call(null,seq__30542__$1);
var G__30557 = c__24249__auto__;
var G__30558 = cljs.core.count.call(null,c__24249__auto__);
var G__30559 = (0);
seq__30542 = G__30556;
chunk__30543 = G__30557;
count__30544 = G__30558;
i__30545 = G__30559;
continue;
} else {
var vec__30549 = cljs.core.first.call(null,seq__30542__$1);
var c = cljs.core.nth.call(null,vec__30549,(0),null);
var p_QMARK_ = cljs.core.nth.call(null,vec__30549,(1),null);
elem__$1.toggleClass(cljs.core.name.call(null,c),cljs.core.boolean$.call(null,p_QMARK_));

var G__30560 = cljs.core.next.call(null,seq__30542__$1);
var G__30561 = null;
var G__30562 = (0);
var G__30563 = (0);
seq__30542 = G__30560;
chunk__30543 = G__30561;
count__30544 = G__30562;
i__30545 = G__30563;
continue;
}
} else {
return null;
}
}
break;
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"toggle","toggle",1291842030),(function (elem,_,v){
return jQuery(elem).toggle(cljs.core.boolean$.call(null,v));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"slide-toggle","slide-toggle",968641513),(function (elem,_,v){
if(cljs.core.truth_(v)){
return jQuery(elem).hide().slideDown("fast");
} else {
return jQuery(elem).slideUp("fast");
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"fade-toggle","fade-toggle",-1468421852),(function (elem,_,v){
if(cljs.core.truth_(v)){
return jQuery(elem).hide().fadeIn("fast");
} else {
return jQuery(elem).fadeOut("fast");
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"focus","focus",234677911),(function (elem,_,v){
return setTimeout((function (){
if(cljs.core.truth_(v)){
return jQuery(elem).focus();
} else {
return jQuery(elem).focusout();
}
}),(0));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"select","select",1147833503),(function (elem,_,___$1){
return jQuery(elem).select();
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"focus-select","focus-select",1107982934),(function (elem,_,v){
if(cljs.core.truth_(v)){
hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"focus","focus",234677911),v);

return hoplon.core.do_BANG_.call(null,elem,new cljs.core.Keyword(null,"select","select",1147833503),v);
} else {
return null;
}
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"text","text",-1790561697),(function (elem,_,v){
return jQuery(elem).text([cljs.core.str.cljs$core$IFn$_invoke$arity$1(v)].join(''));
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"html","html",-998796897),(function (elem,_,v){
return jQuery(elem).html(v);
}));
cljs.core._add_method.call(null,hoplon.core.do_BANG_,new cljs.core.Keyword(null,"scroll-to","scroll-to",-34957602),(function (elem,_,v){
if(cljs.core.truth_(v)){
var body = jQuery("body,html");
var elem__$1 = jQuery(elem);
return body.animate(cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"scrollTop","scrollTop",-1143661921),elem__$1.offset().top], null)));
} else {
return null;
}
}));
jQuery.Event.prototype.cljs$core$IDeref$ = cljs.core.PROTOCOL_SENTINEL;

jQuery.Event.prototype.cljs$core$IDeref$_deref$arity$1 = (function (this$){
var this$__$1 = this;
return jQuery(this$__$1.target).val();
});
cljs.core._add_method.call(null,hoplon.core.on_BANG_,new cljs.core.Keyword("hoplon.core","default","hoplon.core/default",-778824365),(function (elem,event,callback){
return hoplon.core.when_dom.call(null,elem,(function (){
return jQuery(elem).on(cljs.core.name.call(null,event),callback);
}));
}));
cljs.core._add_method.call(null,hoplon.core.on_BANG_,new cljs.core.Keyword("html","*","html/*",-1283138243),(function (elem,event,callback){
return hoplon.core.when_dom.call(null,elem,(function (){
return jQuery(elem).on(cljs.core.name.call(null,event),callback);
}));
}));
